<script setup lang="ts">
import { environment } from "@/environment";
import { computed } from "vue";
import BootstrapCard from "@/components/BootstrapCard.vue";
import {
  useNewsStore,
  useOTRStore,
  useResourceStore,
  useWorkflowExecutionStore,
  useWorkflowStore,
  useS3ObjectStore,
  useS3KeyStore,
  useBucketStore,
  useUserStore,
} from "@/stores";
import {
  ResourceVersionStatus,
  WorkflowExecutionStatus,
  WorkflowVersionStatus,
} from "@/client/types.gen";
import type {
  ResourceOut,
  WorkflowOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import dayjs from "dayjs";
import { latestVersion } from "@/utils/Workflow.ts";
import NewsCard from "@/components/news/NewsCard.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { filesize } from "filesize";

const authStore = useUserStore();
const bucketStore = useBucketStore();
const keyStore = useS3KeyStore();
const objectStore = useS3ObjectStore();
const otrStore = useOTRStore();
const workflowStore = useWorkflowStore();
const executionStore = useWorkflowExecutionStore();
const resourceStore = useResourceStore();
const newsStore = useNewsStore();

function sortWorkflowsByUpdate(a: WorkflowOut, b: WorkflowOut): number {
  return a.versions[0].created_at <= b.versions[0].created_at ? 1 : -1;
}

function sortVersionsByCreation(
  a: WorkflowVersionOut,
  b: WorkflowVersionOut,
): number {
  return a.created_at < b.created_at ? 1 : -1;
}

function sortWorkflows(workflows: WorkflowOut[]): WorkflowOut[] {
  const temp = JSON.parse(
    JSON.stringify(
      workflows.filter((workflow) => workflow.versions.length > 0),
    ),
  );
  for (const index in temp) {
    const versions = [...temp[index].versions];
    versions.sort(sortVersionsByCreation);
    temp[index].versions = versions;
  }
  temp.sort(sortWorkflowsByUpdate);
  return temp;
}

const activeUploadBuckets = computed<string[]>(() => {
  return Object.keys(objectStore.multiPartUploadsMapping).filter(
    (bucketName) => objectStore.multiPartUploadsMapping[bucketName].length > 0,
  );
});

const processedWorkflows = computed<WorkflowOut[]>(() =>
  sortWorkflows(workflowStore.workflows),
);

const processedOwnWorkflows = computed<WorkflowOut[]>(() =>
  sortWorkflows(workflowStore.ownWorkflows),
);

const pendingOwnResourceReviews = computed<number>(() =>
  accumulateResourceStatus(
    resourceStore.ownResources,
    ResourceVersionStatus.WAIT_FOR_REVIEW,
  ),
);

const pendingResourceReviews = computed<number>(() =>
  accumulateResourceStatus(
    resourceStore.reviewableResources,
    ResourceVersionStatus.WAIT_FOR_REVIEW,
  ),
);

const pendingOwnResourceUploads = computed<number>(() =>
  accumulateResourceStatus(
    resourceStore.ownResources,
    ResourceVersionStatus.RESOURCE_REQUESTED,
  ),
);

const pendingOwnWorkflowReviews = computed<number>(() =>
  accumulateWorkflowStatus(
    processedOwnWorkflows.value,
    WorkflowVersionStatus.CREATED,
  ),
);

const pendingWorkflowReviews = computed<number>(() =>
  accumulateWorkflowStatus(
    workflowStore.reviewableWorkflows,
    WorkflowVersionStatus.CREATED,
  ),
);

const activeTokens = computed<number>(() => {
  const time = dayjs().unix();
  return authStore.apiTokens.filter((token) => {
    return (token.expires_at ?? time + 1000) > time;
  }).length;
});

function accumulateResourceStatus(
  resources: ResourceOut[],
  status: ResourceVersionStatus,
): number {
  return resources.reduce(
    (acc, cur) =>
      acc +
      cur.versions.reduce(
        (accVer, curVer) => accVer + (curVer.status == status ? 1 : 0),
        0,
      ),
    0,
  );
}

function accumulateWorkflowStatus(
  workflows: WorkflowOut[],
  status: WorkflowVersionStatus,
): number {
  return workflows.reduce(
    (acc, cur) =>
      acc +
      cur.versions.reduce(
        (accVer: number, curVer: WorkflowVersionOut) =>
          accVer + (curVer.status == status ? 1 : 0),
        0,
      ),
    0,
  );
}
</script>

<template>
  <h2>Dashboard</h2>
  <div class="row p-1 pe-3">
    <div class="col-md-4 order-md-last px-2 mb-md-0 mb-2">
      <h2 class="border-bottom">News</h2>
      <div
        v-if="newsStore.getCurrentNews.length === 0"
        class="fst-italic text-center text-secondary mb-2 mt-md-4 mt-lg-1"
      >
        Currently no news
      </div>
      <div
        v-else
        class="overflow-y-auto"
        style="min-height: 100px; max-height: 80vh"
      >
        <NewsCard
          v-for="event in newsStore.getCurrentNews"
          :key="event.news_id"
          :event="event"
          class="mb-2"
        />
      </div>
    </div>
    <div class="col-md-8">
      <h3>
        <font-awesome-icon icon="fa-solid fa-folder-open" class="me-2" />
        Files
      </h3>
      <div class="d-flex flex-wrap align-items-center">
        <bootstrap-card class="hover-shadow m-2 flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 'buckets' }"
                >My Data Buckets
              </router-link>
            </h5>
          </template>
          <template #body>
            <div>Access to {{ bucketStore.buckets.length }} bucket(s)</div>
            <ul class="mb-0">
              <li>
                {{
                  bucketStore.buckets.filter(
                    (bucket) => bucket.owner_id == authStore.currentUID,
                  ).length
                }}
                own bucket(s)
              </li>
              <li>
                {{
                  bucketStore.buckets.filter(
                    (bucket) => bucket.owner_id != authStore.currentUID,
                  ).length
                }}
                shared bucket(s)
              </li>
              <li>
                {{
                  filesize(
                    bucketStore.ownBuckets
                      .map((bucket) => objectStore.objectMapping[bucket.name])
                      .filter((objs) => objs != undefined)
                      .flat()
                      .reduce((acc, cur) => acc + (cur.Size ?? 0), 0),
                  )
                }}
                in own buckets
              </li>
            </ul>
          </template>
        </bootstrap-card>
        <bootstrap-card class="hover-shadow m-2 flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 'buckets' }"
                >Bucket Ownership Transfers
              </router-link>
            </h5>
          </template>
          <template #body>
            <div>
              {{ otrStore.bucketOtrs.length }} open bucket ownership transfer
              request(s)
            </div>
            <ul class="mb-0">
              <li>
                {{
                  otrStore.bucketOtrs.filter(
                    (otr) => otr.current_owner_uid == authStore.currentUID,
                  ).length
                }}
                pending request(s) to others
              </li>
              <li>
                {{
                  otrStore.bucketOtrs.filter(
                    (otr) => otr.new_owner_uid == authStore.currentUID,
                  ).length
                }}
                request(s) to accept / reject
              </li>
            </ul>
          </template>
        </bootstrap-card>
        <bootstrap-card class="m-2 w-fit hover-shadow flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 's3_keys' }"
                >S3 Bucket Keys
              </router-link>
            </h5>
          </template>
          <template #body>
            <div>{{ keyStore.keys.length }} active key(s)</div>
            <div>S3 Endpoint:</div>
            <a :href="environment.S3_URL">{{ environment.S3_URL }}</a>
          </template>
        </bootstrap-card>
        <bootstrap-card class="m-2 w-fit hover-shadow flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 's3_multipart-uploads' }"
                >Multipart Uploads
              </router-link>
            </h5>
          </template>
          <template #body>
            <div class="card-text">
              {{ activeUploadBuckets.length }} active multipart upload(s)
            </div>
            <template v-if="activeUploadBuckets.length > 0">
              <div>Buckets</div>
              <ul>
                <li v-for="bucketName in activeUploadBuckets" :key="bucketName">
                  {{ bucketName }}:
                  {{ objectStore.multiPartUploadsMapping[bucketName].length }}
                </li>
              </ul>
            </template>
          </template>
        </bootstrap-card>
      </div>
      <h3>
        <font-awesome-icon icon="fa-solid fa-chart-gantt" class="me-2" />
        Workflows
      </h3>
      <div class="d-flex flex-wrap align-items-center">
        <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
          <template #title>
            <h5>
              <router-link :to="{ name: 'workflows' }"
                >{{ processedWorkflows.length }} Available Workflows
              </router-link>
            </h5>
          </template>
          <template #body>
            <div>Latest workflows</div>
            <ul class="mb-0">
              <li
                v-for="workflow in processedWorkflows.slice(0, 3)"
                :key="workflow.workflow_id"
              >
                <router-link
                  :to="{
                    name: 'workflow-version',
                    params: {
                      workflowId: workflow.workflow_id,
                      versionId: latestVersion(workflow.versions)
                        ?.workflow_version_id,
                    },
                  }"
                  >{{ workflow.name }}
                </router-link>
                <br />
                <span class="text-secondary" style="font-size: 0.8rem">
                  Last update
                  {{ dayjs.unix(workflow.versions[0].created_at).fromNow() }}
                </span>
              </li>
            </ul>
          </template>
        </bootstrap-card>
        <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
          <template #title>
            <h5>
              <router-link :to="{ name: 'workflow-executions' }"
                >My Workflow Executions
              </router-link>
            </h5>
          </template>
          <template #body>
            <div>
              Overall {{ executionStore.executions.length }} workflow
              execution(s)
            </div>
            <ul class="mb-0">
              <li>
                {{
                  executionStore.executions.filter(
                    (execution) =>
                      execution.status === WorkflowExecutionStatus.RUNNING ||
                      execution.status === WorkflowExecutionStatus.PENDING ||
                      execution.status === WorkflowExecutionStatus.SCHEDULED,
                  ).length
                }}
                running execution(s)
              </li>
              <li>
                {{
                  executionStore.executions.filter(
                    (execution) =>
                      execution.status === WorkflowExecutionStatus.SUCCESS,
                  ).length
                }}
                successful execution(s)
              </li>
              <li>
                {{
                  executionStore.executions.filter(
                    (execution) =>
                      execution.status === WorkflowExecutionStatus.ERROR,
                  ).length
                }}
                erroneous execution(s)
              </li>
              <li>
                {{
                  executionStore.executions
                    .reduce(
                      (acc, cur) => acc.add(dayjs.duration(cur.cpu_time)),
                      dayjs.duration(0, "day"),
                    )
                    .asHours()
                    .toFixed(2)
                }}
                used CPU hours
              </li>
            </ul>
          </template>
        </bootstrap-card>
      </div>
      <template v-if="authStore.workflowDev">
        <h3>
          <font-awesome-icon icon="fa-solid fa-code" class="me-2" />
          Developer
        </h3>
        <div class="d-flex flex-wrap align-items-center">
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'workflows-developer' }"
                  >My workflows
                </router-link>
              </h5>
            </template>
            <template #body>
              <div>
                {{ processedOwnWorkflows.length }} own workflow(s),
                {{ pendingOwnWorkflowReviews }} pending review(s)
              </div>
              <ul v-if="processedOwnWorkflows.length > 0" class="mb-0">
                <li
                  v-for="workflow in processedOwnWorkflows.slice(0, 3)"
                  :key="workflow.workflow_id"
                >
                  {{ workflow.name }}<br />
                  <span class="text-secondary" style="font-size: 0.8rem">
                    Last update
                    {{
                      dayjs.unix(workflow.versions[0].created_at).fromNow()
                    }}</span
                  >
                </li>
              </ul>
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill">
            <template #title>
              <h5>
                <router-link :to="{ name: 'workflows-developer' }"
                  >Workflow Ownership Transfers
                </router-link>
              </h5>
            </template>
            <template #body>
              <div>
                {{ otrStore.workflowOtrs.length }} open workflow ownership
                transfer request(s)
              </div>
              <ul class="mb-0">
                <li>
                  {{
                    otrStore.workflowOtrs.filter(
                      (otr) => otr.current_owner_uid == authStore.currentUID,
                    ).length
                  }}
                  pending request(s) to others
                </li>
                <li>
                  {{
                    otrStore.workflowOtrs.filter(
                      (otr) => otr.new_owner_uid == authStore.currentUID,
                    ).length
                  }}
                  request(s) to accept / reject
                </li>
              </ul>
            </template>
          </bootstrap-card>
        </div>
      </template>
      <template v-if="authStore.resourceMaintainer">
        <h3>
          <font-awesome-icon icon="fa-solid fa-database" class="me-2" />
          Resource Maintainer
        </h3>
        <div class="d-flex flex-wrap align-items-center">
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'resource-maintainer' }"
                  >My resources
                </router-link>
              </h5>
            </template>
            <template #body>
              <div>{{ resourceStore.ownResources.length }} own resource(s)</div>
              <ul v-if="processedOwnWorkflows.length > 0" class="mb-0">
                <li class="mb-0">
                  {{ pendingOwnResourceUploads }}
                  pending upload(s)
                </li>
                <li class="mb-0">
                  {{ pendingOwnResourceReviews }}
                  pending review(s)
                </li>
              </ul>
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill">
            <template #title>
              <h5>
                <router-link :to="{ name: 'resource-maintainer' }"
                  >Resource Ownership Transfers
                </router-link>
              </h5>
            </template>
            <template #body>
              <div>
                {{ otrStore.resourceOtrs.length }} open workflow ownership
                transfer request(s)
              </div>
              <ul class="mb-0">
                <li>
                  {{
                    otrStore.resourceOtrs.filter(
                      (otr) => otr.current_owner_uid == authStore.currentUID,
                    ).length
                  }}
                  pending request(s) to others
                </li>
                <li>
                  {{
                    otrStore.resourceOtrs.filter(
                      (otr) => otr.new_owner_uid == authStore.currentUID,
                    ).length
                  }}
                  request(s) to accept / reject
                </li>
              </ul>
            </template>
          </bootstrap-card>
        </div>
      </template>
      <template v-if="authStore.reviewer">
        <h3>
          <font-awesome-icon icon="fa-solid fa-magnifying-glass" class="me-2" />
          Reviewer
        </h3>
        <div class="d-flex flex-wrap align-items-center">
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'workflows-reviewer' }"
                  >Workflow Reviews
                </router-link>
              </h5>
            </template>
            <template #body>
              {{ pendingWorkflowReviews }} pending review(s)
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'resource-review' }"
                  >Resource Reviews
                </router-link>
              </h5>
            </template>
            <template #body>
              {{ pendingResourceReviews }} pending review(s)
            </template>
          </bootstrap-card>
        </div>
      </template>
      <h3>
        <font-awesome-icon icon="fa-solid fa-user" class="me-2" />
        Account Management
      </h3>
      <div class="d-flex flex-wrap align-items-center">
        <bootstrap-card class="hover-shadow m-2 flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 'profile' }">My Profile</router-link>
            </h5>
          </template>
          <template #body>
            View your profile and connect it with other login providers
          </template>
        </bootstrap-card>
        <bootstrap-card class="hover-shadow m-2 flex-fill">
          <template #title>
            <h5>
              <router-link :to="{ name: 'api-tokens' }"
                >My personal API tokens
              </router-link>
            </h5>
          </template>
          <template #body>
            {{ authStore.apiTokens.length }} access token(s)
            <ul>
              <li>{{ activeTokens }} active token(s)</li>
              <li>
                {{ authStore.apiTokens.length - activeTokens }} expired token(s)
              </li>
            </ul>
          </template>
        </bootstrap-card>
      </div>
      <template v-if="authStore.admin">
        <h3>
          <font-awesome-icon icon="fa-solid fa-user-gear" class="me-2" />
          Admin
        </h3>
        <div class="d-flex flex-wrap align-items-center">
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-sync-requests' }"
                  >Resource Sync Requests
                </router-link>
              </h5>
            </template>
            <template #body>
              {{ resourceStore.syncRequests.length }} pending sync request(s)
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-users' }">Users</router-link>
              </h5>
            </template>
            <template #body>
              Invite or find users and update their roles
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-tokens' }"
                  >API tokens
                </router-link>
              </h5>
            </template>
            <template #body> Manage all API tokens on the platform</template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-buckets' }"
                  >Buckets
                </router-link>
              </h5>
            </template>
            <template #body>
              Manage all buckets and update their quotas
            </template>
          </bootstrap-card>

          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-resources' }"
                  >Resources
                </router-link>
              </h5>
            </template>
            <template #body>
              Inspect all resources and manage their status
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title>
              <h5>
                <router-link :to="{ name: 'admin-executions' }"
                  >Workflow Executions
                </router-link>
              </h5>
            </template>
            <template #body>
              Search for workflow executions with extensive filters and inspect
              them
            </template>
          </bootstrap-card>
          <bootstrap-card class="hover-shadow m-2 flex-fill w-fit">
            <template #title><h5>News Center</h5></template>
            <template #body>
              Manage all news events on the platform
              <ul>
                <li>
                  <router-link :to="{ name: 'create-news-event' }">
                    Create
                  </router-link>
                </li>
              </ul>
            </template>
          </bootstrap-card>
        </div>
      </template>
    </div>
  </div>
</template>

<style scoped></style>
